/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


#ifndef CB_DBLLINEBOX_H_INCLUDED
#define CB_DBLLINEBOX_H_INCLUDED

#include <aknlists.h>
#include <eikfrlbd.h> 
#include "phonebook.h"
#include "file_output_base.h"

class CPresenceModel : public CAknFilteredTextListBoxModel
{
public:
	CPresenceModel(MDesCArray* aNameArray, MDesCArray* aPresenceArray);
	void ConstructL();
	static CPresenceModel* NewL(MDesCArray* aNameArray, MDesCArray* aPresenceArray);
	void SetFilter(CAknListBoxFilterItems * aFilter);
private:
	virtual TPtrC ItemText(TInt aItemIndex) const;
	virtual TInt NumberOfItems() const;
	virtual const MDesCArray* MatchableTextArray() const;

	MDesCArray* iNameArray;
	MDesCArray* iPresenceArray;
	CAknListBoxFilterItems * iFilter;
};

class doublelinebox : public CEikFormattedCellListBox
{	
	void CreateItemDrawerL(void);
	
public:
	doublelinebox(phonebook_i * aBook, Cfile_output_base * aLog);
	void ConstructL(MDesCArray* aNameArray, MDesCArray* aPresenceArray, const CCoeControl* aParent,TInt aFlags);
	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);
	~doublelinebox();
	void LogVisibleItems(TInt currentItemIndex);
	
	CPresenceModel *iPresenceModel;
	
private:
	void LogItem(const TDesC& item);
	
private:
	phonebook_i * book;
	Cfile_output_base * iLog;
	TBuf<800> iBuf;
	TInt iLastCurrentItemIndex;
	
	
};

class drawer : public CFormattedCellListBoxItemDrawer 
{
public:
	drawer(MTextListBoxModel *aTextListBoxModel, 
					const CFont *aFont, 
					CFormattedCellListBoxData *aFormattedCellData, 
					phonebook_i* aBook, Cfile_output_base * aLog, doublelinebox *aListBox);

private:
	void DrawItemText (TInt aItemIndex, 
								const TRect &aItemTextRect,
                                TBool aItemIsCurrent, 
								TBool aViewIsEmphasized, 
								TBool aItemIsSelected) const;
	
	CFormattedCellListBoxData *itemd;
	MTextListBoxModel * iTextListBoxModel;
	phonebook_i * iBook;
	Cfile_output_base * iLog;
	doublelinebox* iListBox;
};


#endif